package bdchain.api.grpc.acchain;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.20.0)",
    comments = "Source: bdchain/api/ac_chain.proto")
public final class AccountingChainGrpc {

  private AccountingChainGrpc() {}

  public static final String SERVICE_NAME = "bdchain.api.acchain.AccountingChain";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      bdchain.api.grpc.common.ClientVersionResponse> getClientVersionMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "ClientVersion",
      requestType = com.google.protobuf.Empty.class,
      responseType = bdchain.api.grpc.common.ClientVersionResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      bdchain.api.grpc.common.ClientVersionResponse> getClientVersionMethod() {
    io.grpc.MethodDescriptor<com.google.protobuf.Empty, bdchain.api.grpc.common.ClientVersionResponse> getClientVersionMethod;
    if ((getClientVersionMethod = AccountingChainGrpc.getClientVersionMethod) == null) {
      synchronized (AccountingChainGrpc.class) {
        if ((getClientVersionMethod = AccountingChainGrpc.getClientVersionMethod) == null) {
          AccountingChainGrpc.getClientVersionMethod = getClientVersionMethod = 
              io.grpc.MethodDescriptor.<com.google.protobuf.Empty, bdchain.api.grpc.common.ClientVersionResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.acchain.AccountingChain", "ClientVersion"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.protobuf.Empty.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.common.ClientVersionResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new AccountingChainMethodDescriptorSupplier("ClientVersion"))
                  .build();
          }
        }
     }
     return getClientVersionMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.BlockNumberRequest,
      bdchain.api.grpc.acchain.BlockNumberResponse> getBlockNumberMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "BlockNumber",
      requestType = bdchain.api.grpc.acchain.BlockNumberRequest.class,
      responseType = bdchain.api.grpc.acchain.BlockNumberResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.BlockNumberRequest,
      bdchain.api.grpc.acchain.BlockNumberResponse> getBlockNumberMethod() {
    io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.BlockNumberRequest, bdchain.api.grpc.acchain.BlockNumberResponse> getBlockNumberMethod;
    if ((getBlockNumberMethod = AccountingChainGrpc.getBlockNumberMethod) == null) {
      synchronized (AccountingChainGrpc.class) {
        if ((getBlockNumberMethod = AccountingChainGrpc.getBlockNumberMethod) == null) {
          AccountingChainGrpc.getBlockNumberMethod = getBlockNumberMethod = 
              io.grpc.MethodDescriptor.<bdchain.api.grpc.acchain.BlockNumberRequest, bdchain.api.grpc.acchain.BlockNumberResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.acchain.AccountingChain", "BlockNumber"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.BlockNumberRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.BlockNumberResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new AccountingChainMethodDescriptorSupplier("BlockNumber"))
                  .build();
          }
        }
     }
     return getBlockNumberMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetBlockByNumberRequest,
      bdchain.api.grpc.acchain.Block> getGetBlockByNumberMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetBlockByNumber",
      requestType = bdchain.api.grpc.acchain.GetBlockByNumberRequest.class,
      responseType = bdchain.api.grpc.acchain.Block.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetBlockByNumberRequest,
      bdchain.api.grpc.acchain.Block> getGetBlockByNumberMethod() {
    io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetBlockByNumberRequest, bdchain.api.grpc.acchain.Block> getGetBlockByNumberMethod;
    if ((getGetBlockByNumberMethod = AccountingChainGrpc.getGetBlockByNumberMethod) == null) {
      synchronized (AccountingChainGrpc.class) {
        if ((getGetBlockByNumberMethod = AccountingChainGrpc.getGetBlockByNumberMethod) == null) {
          AccountingChainGrpc.getGetBlockByNumberMethod = getGetBlockByNumberMethod = 
              io.grpc.MethodDescriptor.<bdchain.api.grpc.acchain.GetBlockByNumberRequest, bdchain.api.grpc.acchain.Block>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.acchain.AccountingChain", "GetBlockByNumber"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.GetBlockByNumberRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.Block.getDefaultInstance()))
                  .setSchemaDescriptor(new AccountingChainMethodDescriptorSupplier("GetBlockByNumber"))
                  .build();
          }
        }
     }
     return getGetBlockByNumberMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetBlockByHashRequest,
      bdchain.api.grpc.acchain.Block> getGetBlockByHashMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetBlockByHash",
      requestType = bdchain.api.grpc.acchain.GetBlockByHashRequest.class,
      responseType = bdchain.api.grpc.acchain.Block.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetBlockByHashRequest,
      bdchain.api.grpc.acchain.Block> getGetBlockByHashMethod() {
    io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetBlockByHashRequest, bdchain.api.grpc.acchain.Block> getGetBlockByHashMethod;
    if ((getGetBlockByHashMethod = AccountingChainGrpc.getGetBlockByHashMethod) == null) {
      synchronized (AccountingChainGrpc.class) {
        if ((getGetBlockByHashMethod = AccountingChainGrpc.getGetBlockByHashMethod) == null) {
          AccountingChainGrpc.getGetBlockByHashMethod = getGetBlockByHashMethod = 
              io.grpc.MethodDescriptor.<bdchain.api.grpc.acchain.GetBlockByHashRequest, bdchain.api.grpc.acchain.Block>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.acchain.AccountingChain", "GetBlockByHash"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.GetBlockByHashRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.Block.getDefaultInstance()))
                  .setSchemaDescriptor(new AccountingChainMethodDescriptorSupplier("GetBlockByHash"))
                  .build();
          }
        }
     }
     return getGetBlockByHashMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByHashRequest,
      bdchain.api.grpc.acchain.Transaction> getGetTransactionByHashMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactionByHash",
      requestType = bdchain.api.grpc.acchain.GetTransactionByHashRequest.class,
      responseType = bdchain.api.grpc.acchain.Transaction.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByHashRequest,
      bdchain.api.grpc.acchain.Transaction> getGetTransactionByHashMethod() {
    io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByHashRequest, bdchain.api.grpc.acchain.Transaction> getGetTransactionByHashMethod;
    if ((getGetTransactionByHashMethod = AccountingChainGrpc.getGetTransactionByHashMethod) == null) {
      synchronized (AccountingChainGrpc.class) {
        if ((getGetTransactionByHashMethod = AccountingChainGrpc.getGetTransactionByHashMethod) == null) {
          AccountingChainGrpc.getGetTransactionByHashMethod = getGetTransactionByHashMethod = 
              io.grpc.MethodDescriptor.<bdchain.api.grpc.acchain.GetTransactionByHashRequest, bdchain.api.grpc.acchain.Transaction>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.acchain.AccountingChain", "GetTransactionByHash"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.GetTransactionByHashRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.Transaction.getDefaultInstance()))
                  .setSchemaDescriptor(new AccountingChainMethodDescriptorSupplier("GetTransactionByHash"))
                  .build();
          }
        }
     }
     return getGetTransactionByHashMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest,
      bdchain.api.grpc.acchain.Transaction> getGetTransactionByBlockNumberAndIndexMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactionByBlockNumberAndIndex",
      requestType = bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest.class,
      responseType = bdchain.api.grpc.acchain.Transaction.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest,
      bdchain.api.grpc.acchain.Transaction> getGetTransactionByBlockNumberAndIndexMethod() {
    io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest, bdchain.api.grpc.acchain.Transaction> getGetTransactionByBlockNumberAndIndexMethod;
    if ((getGetTransactionByBlockNumberAndIndexMethod = AccountingChainGrpc.getGetTransactionByBlockNumberAndIndexMethod) == null) {
      synchronized (AccountingChainGrpc.class) {
        if ((getGetTransactionByBlockNumberAndIndexMethod = AccountingChainGrpc.getGetTransactionByBlockNumberAndIndexMethod) == null) {
          AccountingChainGrpc.getGetTransactionByBlockNumberAndIndexMethod = getGetTransactionByBlockNumberAndIndexMethod = 
              io.grpc.MethodDescriptor.<bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest, bdchain.api.grpc.acchain.Transaction>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.acchain.AccountingChain", "GetTransactionByBlockNumberAndIndex"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.Transaction.getDefaultInstance()))
                  .setSchemaDescriptor(new AccountingChainMethodDescriptorSupplier("GetTransactionByBlockNumberAndIndex"))
                  .build();
          }
        }
     }
     return getGetTransactionByBlockNumberAndIndexMethod;
  }

  private static volatile io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest,
      bdchain.api.grpc.acchain.Transaction> getGetTransactionByBlockHashAndIndexMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactionByBlockHashAndIndex",
      requestType = bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest.class,
      responseType = bdchain.api.grpc.acchain.Transaction.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest,
      bdchain.api.grpc.acchain.Transaction> getGetTransactionByBlockHashAndIndexMethod() {
    io.grpc.MethodDescriptor<bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest, bdchain.api.grpc.acchain.Transaction> getGetTransactionByBlockHashAndIndexMethod;
    if ((getGetTransactionByBlockHashAndIndexMethod = AccountingChainGrpc.getGetTransactionByBlockHashAndIndexMethod) == null) {
      synchronized (AccountingChainGrpc.class) {
        if ((getGetTransactionByBlockHashAndIndexMethod = AccountingChainGrpc.getGetTransactionByBlockHashAndIndexMethod) == null) {
          AccountingChainGrpc.getGetTransactionByBlockHashAndIndexMethod = getGetTransactionByBlockHashAndIndexMethod = 
              io.grpc.MethodDescriptor.<bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest, bdchain.api.grpc.acchain.Transaction>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "bdchain.api.acchain.AccountingChain", "GetTransactionByBlockHashAndIndex"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  bdchain.api.grpc.acchain.Transaction.getDefaultInstance()))
                  .setSchemaDescriptor(new AccountingChainMethodDescriptorSupplier("GetTransactionByBlockHashAndIndex"))
                  .build();
          }
        }
     }
     return getGetTransactionByBlockHashAndIndexMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static AccountingChainStub newStub(io.grpc.Channel channel) {
    return new AccountingChainStub(channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static AccountingChainBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    return new AccountingChainBlockingStub(channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static AccountingChainFutureStub newFutureStub(
      io.grpc.Channel channel) {
    return new AccountingChainFutureStub(channel);
  }

  /**
   */
  public static abstract class AccountingChainImplBase implements io.grpc.BindableService {

    /**
     */
    public void clientVersion(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.common.ClientVersionResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getClientVersionMethod(), responseObserver);
    }

    /**
     */
    public void blockNumber(bdchain.api.grpc.acchain.BlockNumberRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.BlockNumberResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getBlockNumberMethod(), responseObserver);
    }

    /**
     */
    public void getBlockByNumber(bdchain.api.grpc.acchain.GetBlockByNumberRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Block> responseObserver) {
      asyncUnimplementedUnaryCall(getGetBlockByNumberMethod(), responseObserver);
    }

    /**
     */
    public void getBlockByHash(bdchain.api.grpc.acchain.GetBlockByHashRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Block> responseObserver) {
      asyncUnimplementedUnaryCall(getGetBlockByHashMethod(), responseObserver);
    }

    /**
     */
    public void getTransactionByHash(bdchain.api.grpc.acchain.GetTransactionByHashRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionByHashMethod(), responseObserver);
    }

    /**
     */
    public void getTransactionByBlockNumberAndIndex(bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionByBlockNumberAndIndexMethod(), responseObserver);
    }

    /**
     */
    public void getTransactionByBlockHashAndIndex(bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionByBlockHashAndIndexMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getClientVersionMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.protobuf.Empty,
                bdchain.api.grpc.common.ClientVersionResponse>(
                  this, METHODID_CLIENT_VERSION)))
          .addMethod(
            getBlockNumberMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdchain.api.grpc.acchain.BlockNumberRequest,
                bdchain.api.grpc.acchain.BlockNumberResponse>(
                  this, METHODID_BLOCK_NUMBER)))
          .addMethod(
            getGetBlockByNumberMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdchain.api.grpc.acchain.GetBlockByNumberRequest,
                bdchain.api.grpc.acchain.Block>(
                  this, METHODID_GET_BLOCK_BY_NUMBER)))
          .addMethod(
            getGetBlockByHashMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdchain.api.grpc.acchain.GetBlockByHashRequest,
                bdchain.api.grpc.acchain.Block>(
                  this, METHODID_GET_BLOCK_BY_HASH)))
          .addMethod(
            getGetTransactionByHashMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdchain.api.grpc.acchain.GetTransactionByHashRequest,
                bdchain.api.grpc.acchain.Transaction>(
                  this, METHODID_GET_TRANSACTION_BY_HASH)))
          .addMethod(
            getGetTransactionByBlockNumberAndIndexMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest,
                bdchain.api.grpc.acchain.Transaction>(
                  this, METHODID_GET_TRANSACTION_BY_BLOCK_NUMBER_AND_INDEX)))
          .addMethod(
            getGetTransactionByBlockHashAndIndexMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest,
                bdchain.api.grpc.acchain.Transaction>(
                  this, METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX)))
          .build();
    }
  }

  /**
   */
  public static final class AccountingChainStub extends io.grpc.stub.AbstractStub<AccountingChainStub> {
    private AccountingChainStub(io.grpc.Channel channel) {
      super(channel);
    }

    private AccountingChainStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected AccountingChainStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new AccountingChainStub(channel, callOptions);
    }

    /**
     */
    public void clientVersion(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.common.ClientVersionResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getClientVersionMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void blockNumber(bdchain.api.grpc.acchain.BlockNumberRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.BlockNumberResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getBlockNumberMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getBlockByNumber(bdchain.api.grpc.acchain.GetBlockByNumberRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Block> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetBlockByNumberMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getBlockByHash(bdchain.api.grpc.acchain.GetBlockByHashRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Block> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetBlockByHashMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getTransactionByHash(bdchain.api.grpc.acchain.GetTransactionByHashRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionByHashMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getTransactionByBlockNumberAndIndex(bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionByBlockNumberAndIndexMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getTransactionByBlockHashAndIndex(bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest request,
        io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionByBlockHashAndIndexMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class AccountingChainBlockingStub extends io.grpc.stub.AbstractStub<AccountingChainBlockingStub> {
    private AccountingChainBlockingStub(io.grpc.Channel channel) {
      super(channel);
    }

    private AccountingChainBlockingStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected AccountingChainBlockingStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new AccountingChainBlockingStub(channel, callOptions);
    }

    /**
     */
    public bdchain.api.grpc.common.ClientVersionResponse clientVersion(com.google.protobuf.Empty request) {
      return blockingUnaryCall(
          getChannel(), getClientVersionMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.acchain.BlockNumberResponse blockNumber(bdchain.api.grpc.acchain.BlockNumberRequest request) {
      return blockingUnaryCall(
          getChannel(), getBlockNumberMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.acchain.Block getBlockByNumber(bdchain.api.grpc.acchain.GetBlockByNumberRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetBlockByNumberMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.acchain.Block getBlockByHash(bdchain.api.grpc.acchain.GetBlockByHashRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetBlockByHashMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.acchain.Transaction getTransactionByHash(bdchain.api.grpc.acchain.GetTransactionByHashRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionByHashMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.acchain.Transaction getTransactionByBlockNumberAndIndex(bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionByBlockNumberAndIndexMethod(), getCallOptions(), request);
    }

    /**
     */
    public bdchain.api.grpc.acchain.Transaction getTransactionByBlockHashAndIndex(bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionByBlockHashAndIndexMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class AccountingChainFutureStub extends io.grpc.stub.AbstractStub<AccountingChainFutureStub> {
    private AccountingChainFutureStub(io.grpc.Channel channel) {
      super(channel);
    }

    private AccountingChainFutureStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected AccountingChainFutureStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new AccountingChainFutureStub(channel, callOptions);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.common.ClientVersionResponse> clientVersion(
        com.google.protobuf.Empty request) {
      return futureUnaryCall(
          getChannel().newCall(getClientVersionMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.acchain.BlockNumberResponse> blockNumber(
        bdchain.api.grpc.acchain.BlockNumberRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getBlockNumberMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.acchain.Block> getBlockByNumber(
        bdchain.api.grpc.acchain.GetBlockByNumberRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetBlockByNumberMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.acchain.Block> getBlockByHash(
        bdchain.api.grpc.acchain.GetBlockByHashRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetBlockByHashMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.acchain.Transaction> getTransactionByHash(
        bdchain.api.grpc.acchain.GetTransactionByHashRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionByHashMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.acchain.Transaction> getTransactionByBlockNumberAndIndex(
        bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionByBlockNumberAndIndexMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<bdchain.api.grpc.acchain.Transaction> getTransactionByBlockHashAndIndex(
        bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionByBlockHashAndIndexMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_CLIENT_VERSION = 0;
  private static final int METHODID_BLOCK_NUMBER = 1;
  private static final int METHODID_GET_BLOCK_BY_NUMBER = 2;
  private static final int METHODID_GET_BLOCK_BY_HASH = 3;
  private static final int METHODID_GET_TRANSACTION_BY_HASH = 4;
  private static final int METHODID_GET_TRANSACTION_BY_BLOCK_NUMBER_AND_INDEX = 5;
  private static final int METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX = 6;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final AccountingChainImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(AccountingChainImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_CLIENT_VERSION:
          serviceImpl.clientVersion((com.google.protobuf.Empty) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.common.ClientVersionResponse>) responseObserver);
          break;
        case METHODID_BLOCK_NUMBER:
          serviceImpl.blockNumber((bdchain.api.grpc.acchain.BlockNumberRequest) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.BlockNumberResponse>) responseObserver);
          break;
        case METHODID_GET_BLOCK_BY_NUMBER:
          serviceImpl.getBlockByNumber((bdchain.api.grpc.acchain.GetBlockByNumberRequest) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Block>) responseObserver);
          break;
        case METHODID_GET_BLOCK_BY_HASH:
          serviceImpl.getBlockByHash((bdchain.api.grpc.acchain.GetBlockByHashRequest) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Block>) responseObserver);
          break;
        case METHODID_GET_TRANSACTION_BY_HASH:
          serviceImpl.getTransactionByHash((bdchain.api.grpc.acchain.GetTransactionByHashRequest) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction>) responseObserver);
          break;
        case METHODID_GET_TRANSACTION_BY_BLOCK_NUMBER_AND_INDEX:
          serviceImpl.getTransactionByBlockNumberAndIndex((bdchain.api.grpc.acchain.GetTransactionByBlockNumberAndIndexRequest) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction>) responseObserver);
          break;
        case METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX:
          serviceImpl.getTransactionByBlockHashAndIndex((bdchain.api.grpc.acchain.GetTransactionByBlockHashAndIndexRequest) request,
              (io.grpc.stub.StreamObserver<bdchain.api.grpc.acchain.Transaction>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class AccountingChainBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    AccountingChainBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return bdchain.api.grpc.acchain.AccountingChainProto.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("AccountingChain");
    }
  }

  private static final class AccountingChainFileDescriptorSupplier
      extends AccountingChainBaseDescriptorSupplier {
    AccountingChainFileDescriptorSupplier() {}
  }

  private static final class AccountingChainMethodDescriptorSupplier
      extends AccountingChainBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    AccountingChainMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (AccountingChainGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new AccountingChainFileDescriptorSupplier())
              .addMethod(getClientVersionMethod())
              .addMethod(getBlockNumberMethod())
              .addMethod(getGetBlockByNumberMethod())
              .addMethod(getGetBlockByHashMethod())
              .addMethod(getGetTransactionByHashMethod())
              .addMethod(getGetTransactionByBlockNumberAndIndexMethod())
              .addMethod(getGetTransactionByBlockHashAndIndexMethod())
              .build();
        }
      }
    }
    return result;
  }
}
